当前位置:首页 > 帮助文档 > C++开发 > 图面搜索
简介运行控件函数说明
简介

在本教程的准备文件中已备好所需头文件及源文件,如下所示:


    教程  MyCFilter.h

    教程  MyCFilter.cpp


在本教程中,我们使用控件\MxDraw52\Src\MxDraw5.2\samples\Edit项目进行添加自定义实体演示。

运行控件

运行VS,打开“Edit”项目,添加MyCFilter类(本教程使用已准备好的文件)。在TestCommands.cpp头文件中包含“MyCFilter.h”,并在CTestCommands类的RegisterCommand函数下调用MyFilterByMrxDbgSelSet类的RegisterCommand函数。


    在上述操作中,我们将类及其命令注册进了控件系统,而后我们将调用命令来实现过滤。

    在本实例中,我们将使用构造选择集(Mx::mcedSSGet函数)进行过滤,该函数与用户交互或直接构建选择集,函数调用了空间搜索算法,执行效率高,多用于图面搜索程序,且支持如下过滤条件。


参数类型 类型
RTDXF0 TEXT 文字
MTEXT 多行文字
CIRCLE
ARC 圆弧
LINE 线
LWPOLYLINE 多段线
INSERT 图块
ELLIPSE 椭圆
SPLINE 样条线
LinkLine 超链接
8 图层
2 图块
-4 通配符
62 颜色
-3 扩展数据
函数说明

接下来将解释构造集函数及创建过滤表函数。


mcedSSGet function


作用与用户交互,选择实体。


接口ARXDLL int mcedSSGet (

          LPCTSTR pszStr

          const void * pt1,

          const void * pt2

          const struct resbuf * filter,

          mds_name & ss

          MxSSGetSubEntity * pSubEntitys = NULL

      );


参数


参数类型类型
pszStr_X选择图中的所有实体
_I返回当前图上已经选择的实体
_与用户交互选择实体
_W由p1, p2框选实体,选择的实体必须全部在pt和p2组成的矩形框内
_C由p1, p2交叉框选实体,实体在pt和p2组成的矩形框内或与矩形框边线相交都放入选择集
_POINT由pt1点和当前光标拾取大小生成一个矩形框,再由_C方式构造选择集
_CPpt1指向一个点链表,点集合组成一个多边形区域,在这个区域内的和多边形的边相交的实体都放入到选择集中
_CWpt1指向一个点链表,点集合组成一个多边形区域,在这个区域内的实体都放入到选择集中
pt1输入矩形框的对角点坐标1
pt2输入矩形框的对角点坐标2
filter构造选择集的过滤链表,用实体DXF组码过滤,过滤实体类型使用组码RTDXF0
Ss返回构造的选择集对象,该有对象不使用时,需要调用mcedSSFree函数释放选择集


比如只想选择文字实体,代码如下:


struct resbuf* filter = acutBuildList(RTDXF0, _T("TEXT"), 0);


过滤实体图层组码是8,比如只想选择MYLayer图层上的实体,代码如下:


Struct resbuf* filter = acutBuildList(8, _T("MYLayer"), 0);


图块名的组码是2,比如只想选择图块名为CL的图块,代码如下:


struct resbuf* filter = acutBuildList(2, _T("CL"), 0);


    过滤条件还支持通配符比较和OR(逻辑或),AND(逻辑与)运算,支持把扩展数据应用程序名当着过滤条件。


返回值:成功返回RTNORM,用户取消返回RTCAN。


参考例程


BOOL MxTools::FindEntAtPoint(IN AcGePoint3d pt, IN struct resbuf* pFilter,
IN double dTol, OUT AcDbObjectIdArray& aryId)
{
aryId.setLogicalLength(0);
AcGePoint3d pt1 = pt + dTol * (AcGeVector3d::kXAxis + AcGeVector3d::kYAxis);
AcGePoint3d pt2 = pt - dTol * (AcGeVector3d::kXAxis + AcGeVector3d::kYAxis);
 
ads_name        ss;
int result = acedSSGet(_T("_C"), asDblArray(pt1), asDblArray(pt2), pFilter, ss);
if (result != RTNORM)
{
return FALSE;
}
 
long sslen;
if (acedSSLength(ss, &sslen) != RTNORM)
{
acedSSFree(ss);
return FALSE;
}
 
for (int i = 0; i < sslen; i++)
{
ads_name ent;
acedSSName(ss, i, ent);
 
AcDbObjectId id;
acdbGetObjectId(id, ent);
aryId.append(id);
}
acedSSFree(ss);
 
return !aryId.isEmpty();
}


mcutBuildList function


作用:创建一个链表数据,该函数是变参数的,可以一下传入多个链表数据,返回的链表数据在不使用时调用mcutRelRb释放内存。


接口ARXDLL struct resbuf * mcutBuildList (int rtype, ...);


参数


名称说明

rtype

参数类型

...

变参数


参考例程


void MyFilterBymcedSSGet::FilterByBit()
{
ads_name ss;
 
//按位 “或”
auto pFilter = Mx::mcutBuildList(
-4, L"<OR",
RTDXF0, L"CIRCLE",
8, L"TestColor1",
-4, L"OR>",
0);
Mx::mcedSSGet(L"_X", nullptr, nullptr, pFilter, ss);
PrintVecEntName(ss);
 
//按位 “与”
pFilter = Mx::mcutBuildList(
-4, L"<AND",
RTDXF0, L"CIRCLE",
8, L"SSCP",
-4, L"AND>",
0);
Mx::mcedSSGet(L"_X", nullptr, nullptr, pFilter, ss);
PrintVecEntName(ss);
 
Mx::mcutRelRb(pFilter);
}


    注意:在上述的滤过演示中,我们根据“基本类型”、“图层”、“图块”及“按位OR”和“按位AND”, 在过滤时,我们需要在参数中填入类型,而在后跟类型名,如只选择文字时,我们需要在第一个参数填入“RTDXF0”,而在下一个参数填入类型,这里的类型如都是输入“RTDXF0”类型下的基本类型,则可以使用逗号隔开进行填入,而在连接符号中,我们需要使用成对的符号进行填写。


如选择“基本类型”中的“TEXT”且在“TestColor1”层时,我们需要写成:


Mx::mcutBuildList(
 -4, _T("<AND"), RTDXF0,  _T("TEXT"),
 8, _T("TestColor1"), -4, _T("AND>"),
0));
梦想CAD是专业的CAD插件(控件),可轻松在网页、手机及BS/CS程序中浏览编辑DWG文件,不需安装AutoCAD即可运行。经十余年累积已非常稳定可靠,有关键的空间搜索算法,并使用汇编优化,可同时处理50万级实体,有非常高的图形显示和处理效率。
联系我们
TEL:400-888-5703
185-8173-1060
客服I QQ: 3570505660
技术I QQ: 827867134
技术II QQ:6884123
VIP服务购买
销售TEL:156-8136-8971
销售QQ:710714273
用户交流
控件QQ交流群1:73281982
控件QQ交流群2:112199959
MxCAD软件群 1:515771658
技术I:QQ
827867134
客服I:QQ
3570505660
销售QQ
710714273
联系电话400-888-5703